<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_CruiseSupplement ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_CruiseSupplement extends AbstractStructArrayBase
{
    /**
     * The CruiseSupplement
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_CruiseSupplement[]
     */
    public $CruiseSupplement;
    /**
     * Constructor method for ArrayOfJP_CruiseSupplement
     * @uses ArrayOfJP_CruiseSupplement::setCruiseSupplement()
     * @param \StructType\JP_CruiseSupplement[] $cruiseSupplement
     */
    public function __construct(array $cruiseSupplement = array())
    {
        $this
            ->setCruiseSupplement($cruiseSupplement);
    }
    /**
     * Get CruiseSupplement value
     * @return \StructType\JP_CruiseSupplement[]|null
     */
    public function getCruiseSupplement()
    {
        return $this->CruiseSupplement;
    }
    /**
     * This method is responsible for validating the values passed to the setCruiseSupplement method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCruiseSupplement method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCruiseSupplementForArrayConstraintsFromSetCruiseSupplement(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfJP_CruiseSupplementCruiseSupplementItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_CruiseSupplementCruiseSupplementItem instanceof \StructType\JP_CruiseSupplement) {
                $invalidValues[] = is_object($arrayOfJP_CruiseSupplementCruiseSupplementItem) ? get_class($arrayOfJP_CruiseSupplementCruiseSupplementItem) : sprintf('%s(%s)', gettype($arrayOfJP_CruiseSupplementCruiseSupplementItem), var_export($arrayOfJP_CruiseSupplementCruiseSupplementItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The CruiseSupplement property can only contain items of type \StructType\JP_CruiseSupplement, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set CruiseSupplement value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_CruiseSupplement[] $cruiseSupplement
     * @return \ArrayType\ArrayOfJP_CruiseSupplement
     */
    public function setCruiseSupplement(array $cruiseSupplement = array())
    {
        // validation for constraint: array
        if ('' !== ($cruiseSupplementArrayErrorMessage = self::validateCruiseSupplementForArrayConstraintsFromSetCruiseSupplement($cruiseSupplement))) {
            throw new \InvalidArgumentException($cruiseSupplementArrayErrorMessage, __LINE__);
        }
        $this->CruiseSupplement = $cruiseSupplement;
        return $this;
    }
    /**
     * Add item to CruiseSupplement value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_CruiseSupplement $item
     * @return \ArrayType\ArrayOfJP_CruiseSupplement
     */
    public function addToCruiseSupplement(\StructType\JP_CruiseSupplement $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_CruiseSupplement) {
            throw new \InvalidArgumentException(sprintf('The CruiseSupplement property can only contain items of type \StructType\JP_CruiseSupplement, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->CruiseSupplement[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_CruiseSupplement|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_CruiseSupplement|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_CruiseSupplement|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_CruiseSupplement|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_CruiseSupplement|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string CruiseSupplement
     */
    public function getAttributeName()
    {
        return 'CruiseSupplement';
    }
}
